#!/bin/sh

progname=`basename $0`
tmpfile=`mktemp /tmp/${progname}.XXXXXX` || exit 1

err_exit() {
	echo "*** $1"
	exit 1
}

if [ `id -u` -ne 0 ]; then
	err_exit "need superuser privileges"
fi

kldstat -n cpuctl > /dev/null 2>&1
if [ $? -ne 0 ]; then
	echo "Loading cpuctl.ko"
	kldload cpuctl
	if [ $? -ne 0 ]; then
		err_exit "error loading cpuctl.ko"
	fi
fi

cpucontrol -m 0x277=0x4000000000000000 /dev/cpuctl0 > $tmpfile 2>&1

grep -q ": Bad address" $tmpfile
if [ $? -eq 0 ]; then
	echo "Success"
else
	echo "Failed: cpucontrol output is in $tmpfile"
fi
